package quimufu.colourful_portals.client;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.client.render.fluid.v1.FluidRenderHandler;
import net.minecraft.block.BlockState;
import net.minecraft.client.render.VertexConsumer;
import net.minecraft.client.texture.Sprite;
import net.minecraft.client.texture.SpriteAtlasTexture;
import net.minecraft.fluid.FluidState;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Direction;
import net.minecraft.world.BlockRenderView;
import org.jetbrains.annotations.Nullable;
import quimufu.colourful_portals.ColourfulPortalsMod;

@Environment(value = EnvType.CLIENT)
public class PortalFluidRenderHandler implements FluidRenderHandler, CommonPortalFluidRenderer.VertexEater {
    Identifier PORTAL_FLUID_STILL = new Identifier(ColourfulPortalsMod.MOD_ID, "block/portal_still");

    private final CommonPortalFluidRenderer commonPortalFluidRenderer = new CommonPortalFluidRenderer();
    private Sprite sprite = null;
    private VertexConsumer vertexConsumer;
    private int i;

    private final float[][] vertices = new float[4][5];

    @Override
    public Sprite[] getFluidSprites(@Nullable BlockRenderView view, @Nullable BlockPos pos, FluidState state) {
        return new Sprite[]{sprite};
    }

    @Override
    public int getFluidColor(@Nullable BlockRenderView view, @Nullable BlockPos pos, FluidState state) {
        return 0;
    }

    @Override
    public void renderFluid(BlockPos pos, BlockRenderView world, VertexConsumer vertexConsumer, BlockState blockState, FluidState fluidState) {
        this.vertexConsumer = vertexConsumer;
        BlockPos offset = new BlockPos(pos.getX() & 0xF, pos.getY() & 0xF, pos.getZ() & 0xF);

        commonPortalFluidRenderer.render(world, fluidState, pos, offset, this);


    }


    @Override
    public void reloadTextures(SpriteAtlasTexture textureAtlas) {
        sprite = textureAtlas.getSprite(PORTAL_FLUID_STILL);

    }

    @Override
    public void setSprite(Sprite sprite) {

    }

    @Override
    public void eatVertex(float x, float y, float z, float u, float v) {
        vertices[i][0] = x;
        vertices[i][1] = y;
        vertices[i][2] = z;
        vertices[i][3] = u;
        vertices[i][4] = v;
        i = (i + 1) % 4;
    }

    @Override
    public void drawQuad(BlockPos offset, Direction direction) {
        float offX = offset.getX();
        float offY = offset.getY();
        float offZ = offset.getZ();
        for (float[] v : vertices) {

            vertexConsumer
                    .vertex(offX + v[0], offY + v[1], offZ + v[2])
                    .color(1f, 1f, 1f, 1.0f)
                    .texture( v[3],  v[4])
                    .light(16)
                    .normal(0.0f, 1.0f, 0.0f)
                    .next();

        }


    }
}
